## optee-client-s32 3.18.0

=== CMakeLists.txt ===
project (tee-supplicant C)

################################################################################
# Configuration flags always included
################################################################################
option (CFG_TA_TEST_PATH "Enable tee-supplicant to load from test/debug path" OFF)
option (RPMB_EMU "Enable tee-supplicant to emulate RPMB" ON)
option (CFG_TA_GPROF_SUPPORT "Enable tee-supplicant support for TAs instrumented with gprof" ON)
option (CFG_FTRACE_SUPPORT "Enable tee-supplicant support for TAs instrumented with ftrace" ON)
option (CFG_TEE_SUPP_PLUGINS "Enable tee-supplicant plugin support" ON)

set (CFG_TEE_SUPP_LOG_LEVEL "1" CACHE STRING "tee-supplicant log level")
# FIXME: Question is, is this really needed? Should just use defaults from # GNUInstallDirs?
set (CFG_TEE_CLIENT_LOAD_PATH "/lib" CACHE STRING "Colon-separated list of paths where to look for TAs (see also --ta-dir)")
set (CFG_TEE_FS_PARENT_PATH "/data/tee" CACHE STRING "Location of TEE filesystem (secure storage)")
# FIXME: Why do we have if defined(CFG_GP_SOCKETS) && CFG_GP_SOCKETS == 1 in the c-file?
set (CFG_GP_SOCKETS "1" CACHE STRING "Enable GlobalPlatform Socket API support")
set (CFG_TEE_PLUGIN_LOAD_PATH "/usr/lib/tee-supplicant/plugins/" CACHE STRING "tee-supplicant's plugins path")

if (CFG_TEE_SUPP_PLUGINS)
	set (CMAKE_INSTALL_RPATH "${CFG_TEE_PLUGIN_LOAD_PATH}")
endif()

################################################################################
# Source files
################################################################################
set (SRC
	src/handle.c
	src/hmac_sha2.c
	src/rpmb.c
	src/sha2.c
	src/tee_supp_fs.c
	src/tee_supplicant.c
	src/teec_ta_load.c
)

if (CFG_GP_SOCKETS)
	set (SRC ${SRC} src/tee_socket.c)
endif()

if (CFG_TA_GPROF_SUPPORT OR CFG_FTRACE_SUPPORT)
	set (SRC ${SRC} src/prof.c)
endif()

if (CFG_TEE_SUPP_PLUGINS)
	set (SRC ${SRC} src/plugin.c)
endif()

################################################################################
# Built binary
################################################################################
add_executable (${PROJECT_NAME} ${SRC})

################################################################################
# Flags always set
################################################################################
target_compile_definitions (${PROJECT_NAME}
	PRIVATE -DCFG_TEE_SUPP_LOG_LEVEL=${CFG_TEE_SUPP_LOG_LEVEL}
	PRIVATE -DTEEC_LOAD_PATH="${CFG_TEE_CLIENT_LOAD_PATH}"
	PRIVATE -DTEE_FS_PARENT_PATH="${CFG_TEE_FS_PARENT_PATH}"
	PRIVATE -DBINARY_PREFIX="TSUP"
)

################################################################################
# Optional flags
################################################################################
if (CFG_GP_SOCKETS)
	target_compile_definitions (${PROJECT_NAME}
		PRIVATE -DCFG_GP_SOCKETS=${CFG_GP_SOCKETS})
endif()

if (CFG_TA_TEST_PATH)
	target_compile_definitions (${PROJECT_NAME}
		PRIVATE -DCFG_TA_TEST_PATH=${CFG_TA_TEST_PATH})
endif()

if (RPMB_EMU)
	target_compile_definitions (${PROJECT_NAME}
		PRIVATE -DRPMB_EMU=1)
endif()

if (CFG_TA_GPROF_SUPPORT)
	target_compile_definitions (${PROJECT_NAME}
		PRIVATE -DCFG_TA_GPROF_SUPPORT)
endif()

if (CFG_FTRACE_SUPPORT)
	target_compile_definitions (${PROJECT_NAME}
		PRIVATE -DCFG_FTRACE_SUPPORT)
endif()

if (CFG_TEE_SUPP_PLUGINS)
	target_compile_definitions (${PROJECT_NAME}
		PRIVATE -DTEE_SUPP_PLUGINS
		PRIVATE -DTEE_PLUGIN_LOAD_PATH="${CFG_TEE_PLUGIN_LOAD_PATH}"
	)
endif()

################################################################################
# Public and private header and library dependencies
################################################################################
target_include_directories(${PROJECT_NAME} PRIVATE src)

target_link_libraries (${PROJECT_NAME}
	PRIVATE teec
	PRIVATE optee-client-headers
)

if (CFG_TEE_SUPP_PLUGINS)
	target_link_libraries (${PROJECT_NAME}
		PRIVATE dl
	)
endif()

################################################################################
# Install targets
################################################################################
install (TARGETS ${PROJECT_NAME} RUNTIME DESTINATION ${CMAKE_INSTALL_SBINDIR})

=== Makefile ===
# Public variables are stored in config.mk
include ./config.mk

#########################################################################
# Set Internal Variables						#
# May be modified to match your setup                                   #
#########################################################################
ifneq ($(V),1)
VPREFIX := @
endif
export VPREFIX

EXPORT_DIR ?= $(O)/export
DESTDIR ?= $(EXPORT_DIR)
SBINDIR ?= /usr/sbin
LIBDIR ?= /usr/lib
INCLUDEDIR ?= /usr/include

.PHONY: all build build-libteec build-libckteec build-libseteec install copy_export \
	clean cscope clean-cscope \
	checkpatch-pre-req checkpatch-modified-patch checkpatch-modified-file \
	checkpatch-last-commit-patch checkpatch-last-commit-file \
	checkpatch-base-commit-patch checkpatch-base-commit-file \
	checkpatch-all-files distclean

all: build install

build-libteec:
	@echo "Building libteec.so"
	@$(MAKE) --directory=libteec --no-print-directory --no-builtin-variables \
			CFG_TEE_BENCHMARK=$(CFG_TEE_BENCHMARK) CFG_TEE_CLIENT_LOG_LEVEL=$(CFG_TEE_CLIENT_LOG_LEVEL)

build-tee-supplicant: build-libteec
	@echo "Building tee-supplicant"
	$(MAKE) --directory=tee-supplicant  --no-print-directory --no-builtin-variables CFG_TEE_SUPP_LOG_LEVEL=$(CFG_TEE_SUPP_LOG_LEVEL)

build: build-libteec build-tee-supplicant build-libckteec build-libseteec

build-libckteec: build-libteec
	@echo "Building libckteec.so"
	@$(MAKE) --directory=libckteec --no-print-directory --no-builtin-variables

build-libseteec: build-libteec
	@echo "Building libseteec.so"
	@$(MAKE) --directory=libseteec --no-print-directory --no-builtin-variables

install: copy_export

clean: clean-libteec clean-tee-supplicant clean-cscope clean-libckteec clean-libseteec

clean-libteec:
	@$(MAKE) --directory=libteec --no-print-directory clean

clean-tee-supplicant:
	@$(MAKE) --directory=tee-supplicant --no-print-directory clean

clean-libckteec:
	@$(MAKE) --directory=libckteec --no-print-directory clean

clean-libseteec:
	@$(MAKE) --directory=libseteec --no-print-directory clean

cscope:
	@echo "  CSCOPE"
	${VPREFIX}find ${CURDIR} -name "*.[chsS]" > cscope.files
	${VPREFIX}cscope -b -q -k

clean-cscope:
	${VPREFIX}rm -f cscope.*

# Various checkpatch targets. The ones ending with "patch" only considers the
# patch, whilst the ones ending with "file" checks the complete file.
# +-------------------------------+------------+----------------------------+
# | Target commit                 | File/Patch | Comment                    |
# +-------------------------------+------------+----------------------------+
# | checkpatch-modified-patch     | Patch      | Check local modifications  |
# +-------------------------------+------------+----------------------------+
# | checkpatch-modified-file      | File       | Check Local modifications  |
# +-------------------------------+------------+----------------------------+
# | checkpatch-last-commit-patch  | Patch      | Check against HEAD^        |
# +-------------------------------+------------+----------------------------+
# | checkpatch-last-commit-file   | File       | Check against HEAD^        |
# +-------------------------------+------------+----------------------------+
# | checkpatch-base-commit-patch  | Patch      | Against specic commit      |
# +-------------------------------+------------+----------------------------+
# | checkpatch-base-commit-file   | File       | Against specic commit      |
# +-------------------------------+------------+----------------------------+
# | checkpatch-all-files          | File       | Check all tracked files    |
# +-------------------------------+------------+----------------------------+
CHECKPATCH_IGNORE	?= --ignore NEW_TYPEDEFS --no-signoff
CHECKPATCH_STRICT	?= --strict
CHECKPATCH_ARGS		?= $(CHECKPATCH_IGNORE) $(CHECKPATCH_STRICT) --no-tree --terse
CHECKPATCH_PATCH_ARGS   := $(CHECKPATCH_ARGS) --patch
CHECKPATCH_FILE_ARGS 	:= $(CHECKPATCH_ARGS) --file --no-patch

checkpatch-pre-req:
	@echo "  CHECKPATCH"
ifndef CHECKPATCH
	$(error "Environment variable CHECKPATCH must point to Linux kernels checkpatch script")
else
ifeq (,$(wildcard ${CHECKPATCH}))
	$(error "CHECKPATCH points to the incorrect file")
endif
endif

checkpatch-modified-patch: checkpatch-pre-req
	${VPREFIX}git diff | ${CHECKPATCH} $(CHECKPATCH_PATCH_ARGS) - || true

checkpatch-modified-file: checkpatch-pre-req
	${VPREFIX}${CHECKPATCH} $(CHECKPATCH_FILE_ARGS) $(shell git diff --name-only)


checkpatch-last-commit-patch: checkpatch-pre-req
	${VPREFIX}git diff HEAD^ | ${CHECKPATCH} $(CHECKPATCH_PATCH_ARGS) - || true

checkpatch-last-commit-file: checkpatch-pre-req
	${VPREFIX}${CHECKPATCH} $(CHECKPATCH_FILE_ARGS) $(shell git diff --name-only HEAD^)


checkpatch-base-commit-patch: checkpatch-pre-req
ifndef BASE_COMMIT
	$(error "Environment variable BASE_COMMIT must contain a valid commit")
endif
	${VPREFIX}git diff $(BASE_COMMIT) | ${CHECKPATCH} $(CHECKPATCH_PATCH_ARGS) - || true

checkpatch-base-commit-file: checkpatch-pre-req
ifndef BASE_COMMIT
	$(error "Environment variable BASE_COMMIT must contain a valid commit")
endif
	${VPREFIX}${CHECKPATCH} $(CHECKPATCH_FILE_ARGS) $(shell git diff --name-only ${BASE_COMMIT})

checkpatch-all-files: checkpatch-pre-req
	${VPREFIX}${CHECKPATCH} $(CHECKPATCH_FILE_ARGS) $(shell git ls-files)

distclean: clean

copy_export: build
	mkdir -p $(DESTDIR)$(SBINDIR) $(DESTDIR)$(LIBDIR) $(DESTDIR)$(INCLUDEDIR)
	cp config.mk $(DESTDIR)/$(INCLUDEDIR)/optee_client_config.mk
	cp -d ${O}/libteec/libteec.so* $(DESTDIR)$(LIBDIR)
	cp -d ${O}/libteec/libteec.a $(DESTDIR)$(LIBDIR)
	cp ${O}/tee-supplicant/tee-supplicant $(DESTDIR)$(SBINDIR)
	cp public/*.h $(DESTDIR)$(INCLUDEDIR)
	cp libckteec/include/*.h $(DESTDIR)$(INCLUDEDIR)
	cp -d ${O}/libckteec/libckteec.so* $(DESTDIR)$(LIBDIR)
	cp -d ${O}/libckteec/libckteec.a $(DESTDIR)$(LIBDIR)
	cp libseteec/include/*.h $(DESTDIR)$(INCLUDEDIR)
	cp -d ${O}/libseteec/libseteec.so* $(DESTDIR)$(LIBDIR)
	cp -d ${O}/libseteec/libseteec.a $(DESTDIR)$(LIBDIR)

=== debian/changelog ===
optee-client-s32 (3.18.0-0ubuntu1) noble; urgency=medium

  * Initial release to Ubuntu (LP: #2039036)

 -- Laider Lai <laider.lai@canonical.com>  Thu, 22 Feb 2024 03:33:34 +0000

=== debian/control ===
Source: optee-client-s32
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Isaac True <isaac.true@canonical.com>
Uploaders: Isaac True <isaac.true@canonical.com>
Build-Depends: debhelper-compat (= 12), docbook-xsl, xsltproc
Standards-Version: 4.5.1
Section: libs
Homepage: https://github.com/OP-TEE/optee_client
Rules-Requires-Root: no

Package: optee-client-s32-dev
Section: libdevel
Architecture: arm64 armhf
Multi-Arch: same
Depends: libckteec0-s32 (= ${binary:Version}),
         libseteec0-s32 (= ${binary:Version}),
         libteec1-s32 (= ${binary:Version}),
         ${misc:Depends}
Conflicts: optee-client-dev
Provides: optee-client-dev
Description: normal world user space client APIs for OP-TEE (development)
 OP-TEE is a Trusted Execution Environment (TEE) designed as companion to a
 non-secure Linux kernel running on Arm; Cortex-A cores using the TrustZone
 technology. OP-TEE implements TEE Internal Core API v1.1.x which is the API
 exposed to Trusted Applications and the TEE Client API v1.0, which is the
 API describing how to communicate with a TEE. This package provides the TEE
 Client API library.
 .
 This package contains the development files OpTEE Client API for NXP S32

Package: libteec1-s32
Architecture: arm64 armhf
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libteec1
Provides: libteec1
Description: normal world user space client APIs for OP-TEE
 OP-TEE is a Trusted Execution Environment (TEE) designed as companion to a
 non-secure Linux kernel running on Arm; Cortex-A cores using the TrustZone
 technology. OP-TEE implements TEE Internal Core API v1.1.x which is the API
 exposed to Trusted Applications and the TEE Client API v1.0, which is the
 API describing how to communicate with a TEE. This package provides the TEE
 Client API library.
 .
 This package contains libteec library for NXP S32.

Package: libckteec0-s32
Architecture: arm64 armhf
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libckteec0
Provides: libckteec0
Description: normal world user space client APIs for OP-TEE
 OP-TEE is a Trusted Execution Environment (TEE) designed as companion to a
 non-secure Linux kernel running on Arm; Cortex-A cores using the TrustZone
 technology. OP-TEE implements TEE Internal Core API v1.1.x which is the API
 exposed to Trusted Applications and the TEE Client API v1.0, which is the
 API describing how to communicate with a TEE. This package provides the TEE
 Client API library.
 .
 This package contains libckteec library for NXP S32.

Package: libseteec0-s32
Architecture: arm64 armhf
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libseteec0
Provides: libseteec0
Description: normal world user space client APIs for OP-TEE
 OP-TEE is a Trusted Execution Environment (TEE) designed as companion to a
 non-secure Linux kernel running on Arm; Cortex-A cores using the TrustZone
 technology. OP-TEE implements TEE Internal Core API v1.1.x which is the API
 exposed to Trusted Applications and the TEE Client API v1.0, which is the
 API describing how to communicate with a TEE. This package provides the TEE
 Client API library.
 .
 libseteec stands for secure element control.
 .
 This package contains libseteec library for NXP S32.

Package: tee-supplicant-s32
Architecture: arm64 armhf
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: tee-supplicant
Provides: tee-supplicant
Description: normal world user space client APIs for OP-TEE
 OP-TEE is a Trusted Execution Environment (TEE) designed as companion to a
 non-secure Linux kernel running on Arm; Cortex-A cores using the TrustZone
 technology. OP-TEE implements TEE Internal Core API v1.1.x which is the API
 exposed to Trusted Applications and the TEE Client API v1.0, which is the
 API describing how to communicate with a TEE. This package provides the TEE
 Client API library.
 .
 This package contains tee-supplicant executable for NXP S32.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@ --exclude=.a

override_dh_auto_build: tee-supplicant-s32.8
	dh_auto_build -- LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
		CFG_TEE_FS_PARENT_PATH=/var/lib/optee-client/data/tee

override_dh_auto_install:
	dh_auto_install -- LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
		CFG_TEE_FS_PARENT_PATH=/var/lib/optee-client/data/tee

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(CURDIR)/out

DB2MAN = /usr/share/sgml/docbook/stylesheet/xsl/docbook-xsl/manpages/docbook.xsl
XP     = xsltproc -''-nonet -''-param man.charmap.use.subset "0"

tee-supplicant-s32.8: debian/tee-supplicant-s32.8.xml
	$(XP) $(DB2MAN) $<
